.586    
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD

include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\msimg32.inc
include \masm32\include\comdlg32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\msimg32.lib
includelib \masm32\lib\comdlg32.lib

.const

MainWindowWidth     equ     600
MainWindowHeight    equ     350

.data

hInstance       dd      ?
hMainWindow     dd      ?
MainWindowClass db      'MainWindowClass',0
MainWindowName  db      '???',0

wc          WNDCLASSEX  <sizeof wc,CS_HREDRAW+CS_VREDRAW,offset WndProc,NULL,NULL,NULL, \
                        NULL,NULL,COLOR_WINDOW,NULL,offset MainWindowClass,NULL>
hDC             HDC     ?                        
hMemDC          HDC     ?
hTDC            HDC     ?
pt              POINT       <>
ps              PAINTSTRUCT     <>
cc              CHOOSECOLOR     <sizeof cc,?,?,?,offset Colors,CC_FULLOPEN,NULL,NULL,offset TemplateName>
Colors          dd      0,1,2,3,4,5,6,7
                dd      8,9,10,11,12,13,14,15
TemplateName    db      'COLORS',0   
rect            RECT        <>             
                        
.code
    start:
        invoke  GetModuleHandle,NULL
        mov hInstance,eax
        invoke  WinMain,hInstance,NULL,NULL,SW_SHOWNORMAL
        invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

    local   msg:MSG

    push    hInstance
    pop     wc.hInstance
    invoke  LoadIcon,NULL,IDI_APPLICATION
    mov     wc.hIcon,eax
    mov     wc.hIconSm,eax
    invoke  LoadCursor,NULL,IDC_ARROW
    mov     wc.hCursor,eax
    invoke	GetStockObject,BLACK_BRUSH
    mov	wc.hbrBackground,eax
    invoke  RegisterClassEx,addr wc
    invoke  GetSystemMetrics,SM_CYSCREEN
    shr     eax,1
    sub     eax,MainWindowHeight/2
    push    eax
    invoke  GetSystemMetrics,SM_CXSCREEN
    shr     eax,1
    sub     eax,MainWindowWidth/2
    pop     ebx
    invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\   
               eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
    mov     hMainWindow,eax
    invoke  ShowWindow,eax,CmdShow
    invoke  UpdateWindow,hMainWindow

msg_loop:
    invoke  GetMessage,addr msg,NULL,0,0
    or      eax,eax
    jz      end_msg_loop
    invoke  TranslateMessage,addr msg
    invoke  DispatchMessage,addr msg
    jmp     msg_loop
end_msg_loop:
    mov     eax,msg.wParam
    ret

WinMain     endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD

    .if uMsg==WM_DESTROY
        invoke  PostQuitMessage,NULL
	.elseif	uMsg==WM_CREATE
		mov		edi,lParam
		.if	[edi.CREATESTRUCT].hWndParent==NULL
                    invoke  GetClientRect,hWnd,addr rect
			  invoke  GetDesktopWindow
                    push    eax
                    invoke  GetDC,eax
                    mov     hDC,eax
                    invoke  CreateCompatibleDC,eax
                    mov     hMemDC,eax
                    invoke  GetSystemMetrics,SM_CYSCREEN
                    push    eax
                    invoke  GetSystemMetrics,SM_CXSCREEN
                    pop     ebx
                    invoke  CreateCompatibleBitmap,hDC,eax,ebx
                    invoke  SelectObject,hMemDC,eax
                    invoke  DeleteObject,eax
                    pop     eax
                    invoke  ReleaseDC,eax,hDC
                    invoke  BitBlt,hMemDC,0,0,10000,10000,hMemDC,10000,10000,PATCOPY
   
                    invoke  GetDesktopWindow
                    push    eax
                    invoke  GetDC,eax
                    mov     hDC,eax
                    invoke  CreateCompatibleDC,eax
                    mov     hTDC,eax
                    invoke  CreateCompatibleBitmap,hDC,1000,1000
                    invoke  SelectObject,hTDC,eax
                    pop     eax
                    invoke  ReleaseDC,eax,hDC
                    invoke  BitBlt,hTDC,0,0,10000,10000,hTDC,10000,10000,PATCOPY
                    push    hWnd
                    pop     cc.hwndOwner
                    push    hInstance
                    pop     wc.hInstance
                    invoke  ChooseColor,addr cc
		.endif
    .elseif uMsg==WM_PAINT
        invoke  BeginPaint,hWnd,addr ps
        invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right,ps.rcPaint.bottom,hMemDC,\
                        ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        invoke  BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,ps.rcPaint.right,ps.rcPaint.bottom,hTDC,\
                        ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
        invoke  BitBlt,hTDC,0,0,10000,10000,hTDC,10000,10000,PATCOPY                        
        invoke  EndPaint,hWnd,addr ps

    .elseif uMsg==WM_LBUTTONDOWN
        mov     eax,lParam
        mov     ebx,eax
        movzx   eax,ax
        shr     ebx,16
        push    eax
        pop     pt.x
        push    ebx
        pop     pt.y            
    .elseif uMsg==WM_MOUSEMOVE
        .if wParam==MK_LBUTTON
            mov     eax,lParam
            mov     ebx,eax
            movzx   eax,ax
            shr     ebx,16
            push    eax
            push    ebx
            invoke  CreatePen,PS_SOLID,4,cc.rgbResult
            invoke  SelectObject,hTDC,eax
            pop     ebx
            pop     eax
            invoke  Ellipse,hTDC,pt.x,pt.y,eax,ebx
            invoke  InvalidateRect,hWnd,addr rect,FALSE
        .endif                                                                        
    .else
        invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
        ret
    .endif
    xor eax,eax
    ret

WndProc     endp

end	start